POJ - 3126 -Prime Path 搜索 BFS

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
题意:
给定两个四位素数op ed,要求把op变换到ed
变换的过程要保证 每次变换出来的数都是一个 四位素数,而且当前这步的变换所得的素数 与 前一步得到的素数 只能有一个位不同,而且每步得到的素数都不能重复。
求从a到b最少需要的变换次数。无法变换则输出Impossible
思路:
BFS,对各个位进行遍历
无论是判定素数还是搜索素数,首先排除偶数,这样就剪掉一半枝叶了
注意:千位的变换要保证千位不为0

其实素数也是用来辅助搜索剪枝的

大佬说的:

你如果不了解STL的内部实现逻辑或者没看过代码,还是少用,因为使用不当就会拖慢程序效率的。STL的queue是在deque基础上封装的,而deque维护的是一个双端队列。换而言之,queue的数据结构决定了,其入队和出队操作的时间复杂度都是 0(n),而不是你以为的O(1)。随着队列元素的增长,queue的出入队效率越差。

#include"iostream"
#include"cstdio"
#include"stdlib.h"
#include"cmath"
#include"cstring"
#include"cstdlib"
#include"vector"
#include"stack"
#include"queue"
#include"set"
#include"map"
#include"algorithm"
#include <utility>
#include <iomanip>
#include <time.h>
#include<list>
using namespace std;
#define MIN(a, b) ((a)<(b)?(a):(b))
typedef long long ll;
const int M=15005;
/*
typedef class
{
	public:
		int prime;
		int step;
}number;
*/
struct node
{

    int prime;
    int step;
} qe[M];
bool vis[M];


int dir[4][4]= {0,1,0,-1,1,0,-1,0};
int t,op,ed;//样例,初始的数字,变化后的数字
bool JudgePrime(int digit) //素数判断
{
    if(digit==2 || digit==3)
        return true;
    else if(digit<=1 || digit%2==0)
        return false;
    else if(digit>3)
    {
        for(int i=3; i*i<=digit; i+=2)
            if(digit%i==0)
                return false;
        return true;
    }
}
void bfs()
{

    int head,tail;//模拟队列,头指针和尾指针

    qe[head=tail=0].prime=op;
    qe[tail++].step=0;
    vis[op]=true;

    while(head<tail)
    {
        node tmp=qe[head++];
        if(tmp.prime==ed)//结束
        {
            cout<<tmp.step<<endl;
            return;
        }

        int one=tmp.prime%10;//获取个位
        int two=tmp.prime/10%10;//获取十位

        for(int i=1; i<=9; i+=2) //枚举tmp的个位,保证四位数为奇数(偶数必不是素数)
        {
            int j=(tmp.prime/10)*10+i;
            if(j!=tmp.prime&&!vis[j]&&JudgePrime(j))
            {
                qe[tail].prime=j;
                qe[tail++].step=tmp.step+1;
                vis[j]=true;
            }
        }
        for(int i=0; i<=9; i++) //十位
        {
            int j=(tmp.prime/100)*100+i*10+one;
            if(j!=tmp.prime&&!vis[j]&&JudgePrime(j))
            {
                qe[tail].prime=j;
                qe[tail++].step=tmp.step+1;
                vis[j]=true;
            }
        }
        for(int i=0; i<=9; i++) //百位
        {
            int j=(tmp.prime/1000)*1000+i*100+two*10+one;
            if(j!=tmp.prime&&!vis[j]&&JudgePrime(j))
            {
                qe[tail].prime=j;
                qe[tail++].step=tmp.step+1;
                vis[j]=true;
            }
        }
        for(int i=1; i<=9; i++) //枚举tmp的千位,保证四位数,千位最少为1
        {
            int j=tmp.prime%1000+i*1000;
            if(j!=tmp.prime&&!vis[j]&&JudgePrime(j))
            {
                qe[tail].prime=j;
                qe[tail++].step=tmp.step+1;
                vis[j]=true;
            }
        }
    }
    cout<<"Impossible"<<endl;
    return;
}
int main()
{
    ios::sync_with_stdio(0);
    cin>>t;
    while(t--)
    {
        cin>>op>>ed;
        memset(vis,false,sizeof(vis));
        bfs();
    }
    return 0;
}



评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值